package cbsw;

import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.NONE)
public class Command
{
@XmlAttribute
public String label;
@XmlAttribute
public String targetMethod;
@XmlAttribute
public String targetClass;
@XmlAttribute
public String data;
    
javax.swing.JButton button;

public Command(){}

/**
<p>Parses, calls and handles reponses for a command.</p>
<p>Use Java reflection to call the static exec method of the target class.
Allows multiple groups of target method args that are applied repeatedly to the same method.</p>
@throws Exception The exception
*/
public void go() throws Exception
{
  try
  {

    // Split the groups of target method args at the ? character
    
    String [] dataTokenised = (data==null) ? new String []{""} : data.split("\\?");
  
    if (button!=null) button.setBackground(java.awt.Color.YELLOW); // Command send

    for (String targetMethodData : dataTokenised)
    {
	//      System.out.println(targetMethodData);
      String [] targetMethodArgs = targetMethodData.split("\\|");

      String rv = (String)Command.exec(Class.forName("cbsw."+targetClass), targetMethod, targetMethodArgs);
      //      Sequence.textArea.append(rv+"\n");
      if (!rv.substring(0,2).equals("OK")) throw new RuntimeException(rv);
    }
    if (button!=null) button.setBackground(new java.awt.Color(220,220,220)); // All done.
  }
  catch (Exception ex)
  {
    if (button!=null) button.setBackground(java.awt.Color.ORANGE);
    throw new Exception("Command.go(): "+ex+" for "+targetMethod+"["+data+"]");
  }
}

/**
<p>Calls a static method by Java reflection.</p>
@param targetClass The class of the method.
@param targetMethod The method.
@param targetArgs Command line parameters.
@return The command response
 */
public static Object exec(Class<?> targetClass, String targetMethod, String [] targetArgs)
{
    //  System.out.println(String.format("Command.exec(): %s.%s()",targetClass.toString(),targetMethod));
  Object rv = null;
  try
  {
    java.lang.reflect.Method method = targetClass.getMethod(targetMethod,String[].class);
    rv = method.invoke(targetClass,new Object[] {targetArgs});
  }
  catch (Exception ex) {System.err.println(String.format("Command.exec(): %s for %s.%s()",ex,targetClass,targetMethod));}
  return rv;
}

public void setButton(javax.swing.JButton button){this.button = button;}
}
