package cbsw;

/**
<p>Byte-oriented hardware I/O interface</p>
 */
public interface RegisterIo
{
/**
<p>Write array of bytes to hardware</p>
@param base Hardware address
@param offset Hardware byte offset where to start writing
@param buf data to write
@throws RegisterIoException RegisterIo exception
 */
  void put(int base, int offset, byte [] buf) throws RegisterIoException;
/**
<p>Write ByteBuffer to hardware</p>
@param base Hardware address
@param bb data to write
@throws RegisterIoException RegisterIo exception
 */
  void put(int base, java.nio.ByteBuffer bb) throws RegisterIoException;
/**
<p>Read array of bytes from hardware</p>
@param base Hardware address
@param addr Register start address offset
@param regs array to receive data
@throws RegisterIoException RegisterIo exception
 */
  void get(int base, int addr, byte [] regs) throws RegisterIoException;
/**
<p>Read array of bytes from hardware</p>
@param base Hardware address
@param regs array to receive data
@throws RegisterIoException RegisterIo exception
 */
  void get(int base, byte [] regs) throws RegisterIoException;
/**
<p>Close I/O device</p>
 */
  void close();
}
