/*
Unmarshall GBTX register descriptors into statically accessible members of this Gbtx class.
Note that the class members are static but unfortunately not immutable because of the need to use JAXB setters.
See main() for example.
*/
package cbsw.lhcb.pdmdb;

import java.util.prefs.Preferences;
import javax.xml.bind.annotation.*;
import java.util.*;

/**
<p>This class encapsulates the GBTX register set.</p>
**/
@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(name="gbtx")
class Gbtx
{
public static int csrSize;
public static ArrayList<GbtxRegisterDescriptor> descriptors;
public static ArrayList<String> fsmStates;
public static HashMap<String,GbtxRegisterDescriptor> map;

  @XmlAttribute
  public void setCsrSize(int csrSize){Gbtx.csrSize = csrSize;}

  @XmlElement(name="register")
  public void setDescriptors(ArrayList<GbtxRegisterDescriptor> descriptors)
  {
    Gbtx.descriptors = descriptors;
  }
  public ArrayList<GbtxRegisterDescriptor> getDescriptors(){return descriptors;}
    
  @XmlElement(name="fsmState")
  public void setFsmStates(ArrayList<String> fsmStates) { Gbtx.fsmStates = fsmStates; }
  public ArrayList<String> getFsmStates(){return fsmStates;}
    
  static
  {
    cbsw.Cbsw.unmarshal("https://www.hep.phy.cam.ac.uk/lhcb/PDMDB/xml/gbtx.xml",Gbtx.class);
    Gbtx.map = new HashMap<String,GbtxRegisterDescriptor>();
    for (GbtxRegisterDescriptor reg : Gbtx.descriptors){ Gbtx.map.put(reg.getName(),reg); }
  }
    
  public Gbtx(){}

  public static void decode(BitSet csrBitSet)
  {
    if (csrBitSet==null) return;
    for (GbtxRegisterDescriptor reg : Gbtx.descriptors)
    {
      System.out.println(reg.getName()+": "+reg.get(csrBitSet));
    } 
    return;
  }
    
  public static void main( String[] args )
  {
    System.out.println(Gbtx.csrSize);
    System.out.println(Gbtx.fsmStates.get(10));
    for (GbtxRegisterDescriptor reg : Gbtx.descriptors){ System.out.println(reg.getName()); }  
  }

}

