package cbsw.gui;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.prefs.*;
import java.text.Format;
import javax.swing.filechooser.*;

public class GuiPreferences
{
    
static ActionListener importAL = new ActionListener () { public void actionPerformed(ActionEvent e)
{
   importPreferences();
   return;
}
};

static ActionListener exportAL = new ActionListener () { public void actionPerformed(ActionEvent e)
{
   exportPreferences(null);
   return;
}
};

  public static void addMenuItems(JMenu m)
  {
    JMenuItem menuItem = new JMenuItem("Import...");
    menuItem.addActionListener( importAL );
    m.add(menuItem);

    menuItem = new JMenuItem("Export...");
    menuItem.addActionListener( exportAL );
    m.add(menuItem);
  }
    
  // Save settings for all JCheckBox and JTextField components of a Container.
  // The preferences name is taken from the component name.
  // Function is recursive
  public static void savePreferences(Preferences prefs, Container cn)
  {
    if (prefs == null) {System.out.println("GuiJPanel.savePreferences(): Null prefs. Aborting...");return;}
    if (cn == null) {System.out.println("GuiJPanel.savePreferences(): Null container. Aborting...");return;}
    for (Component component : cn.getComponents())
    {
      if (component == null) {System.out.println("GuiJPanel.savePreferences(): Null component. Aborting...");continue;}
      if (component instanceof JCheckBox)
      {
	if (component.getName() == null) { System.out.println("CheckBox component name is null"); continue; }
	System.out.println(prefs.absolutePath()+"/"+component.getName()+"="+((JCheckBox)component).isSelected());
	prefs.putBoolean( component.getName(),((JCheckBox)component).isSelected());
      }
      else if (component instanceof JTextField) // also for JFormattedTextField
      {
	if (component.getName() == null) { System.out.println("TextField component name is null"); continue; }
	if (((JTextField)component).getText() == null) { System.out.println( "TextField text is null"); continue; }
	System.out.println(prefs.absolutePath()+"/"+component.getName()+"="+((JTextField)component).getText());
	prefs.put( component.getName(),((JTextField)component).getText());
      }
      else if (component instanceof Container) // Recursive
      {
	savePreferences(prefs, (Container)component);
      }
    }
  }

  public static void updateFields(Preferences prefs, Container cn)
  {
    if (prefs == null) {System.out.println("GuiJPanel.savePreferences(): Null prefs. Aborting...");return;}
    if (cn == null) {System.out.println("GuiJPanel.savePreferences(): Null container. Aborting...");return;}
    for (Component component : cn.getComponents())
    {
      if (component == null) {System.out.println("GuiJPanel.updateFields(): Null component. Aborting...");continue;}
      if (component instanceof JCheckBox)
      {
	if (component.getName() == null) { System.out.println("CheckBox component name is null"); continue; }
	((JCheckBox)component).setSelected(prefs.getBoolean( component.getName(),false));
      }
      else if (component instanceof JTextField) // also for JFormattedTextField
      {
	if (component.getName() == null) { System.out.println("TextField component name is null"); continue; }
	if (((JTextField)component).getText() == null) { System.out.println( "TextField text is null"); continue; }
	((JTextField)component).setText(prefs.get( component.getName(),""));
      }
      else if (component instanceof Container) // Recursive
      {
	updateFields(prefs, (Container)component);
      }
    }
  }

  public static void updateUndefinedFields(Preferences prefs, Container cn)
  {
    if (prefs == null) {System.out.println("GuiJPanel.savePreferences(): Null prefs. Aborting...");return;}
    if (cn == null) {System.out.println("GuiJPanel.savePreferences(): Null container. Aborting...");return;}
    for (Component component : cn.getComponents())
    {
      if (component == null) {System.out.println("GuiJPanel.updateFields(): Null component. Aborting...");continue;}
      if (component instanceof JCheckBox)
      {
	if (component.getName() == null) { System.out.println("CheckBox component name is null"); continue; }
        if (!prefs.get(component.getName(),"").equals("")) ((JCheckBox)component).setSelected(prefs.getBoolean( component.getName(),false));
      }
      else if (component instanceof JTextField) // also for JFormattedTextField
      {
	if (component.getName() == null) { System.out.println("TextField component name is null"); continue; }
	if (((JTextField)component).getText() == null) { System.out.println( "TextField text is null"); continue; }
	if (!prefs.get(component.getName(),"").equals("")) ((JTextField)component).setText(prefs.get( component.getName(),""));
      }
      else if (component instanceof Container) // Recursive
      {
	updateUndefinedFields(prefs, (Container)component);
      }
    }
  }

  public static void importPreferences()
  {
    JFileChooser chooser = new JFileChooser();
    FileNameExtensionFilter filter = new FileNameExtensionFilter( "Preferences (XML)", "xml" );
    chooser.setFileFilter(filter);
    int returnVal = chooser.showOpenDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
	  // Import preferences in XML file
      try
      {   
	FileInputStream prefsStream = new FileInputStream(chooser.getSelectedFile());
	Preferences.userRoot().importPreferences(prefsStream);
	prefsStream.close();
      }
      catch (IOException ex) { ex.printStackTrace(); }
      catch (InvalidPreferencesFormatException ex) { ex.printStackTrace(); }
    }
 
    return;
  }

  public static void exportPreferences(String prefsPath)
  {
    if (prefsPath == null) prefsPath = JOptionPane.showInputDialog("Enter preferences path");
    if (prefsPath == null) return;

    JFileChooser chooser = new JFileChooser();
    FileNameExtensionFilter filter = new FileNameExtensionFilter( "Preferences (XML)", "xml" );
    chooser.setFileFilter(filter);
    int returnVal = chooser.showOpenDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      // Save prefences in XML file
      try
      {   
        FileOutputStream prefsStream = new FileOutputStream(chooser.getSelectedFile());
        Preferences.userRoot().node(prefsPath).exportSubtree(prefsStream);
        prefsStream.close();
      }
      catch (IOException ex) { ex.printStackTrace(); }
      catch (BackingStoreException ex) { ex.printStackTrace(); }
    }
 
    return;
  }
}

