package cbsw.lhcb.pdmdb;

/**
<p>This class is an adapter used during unmarshalling of GBTX instances.</p>
**/
public final class GbtxAdapter extends javax.xml.bind.annotation.adapters.XmlAdapter<GbtxType,GbtxParent>
{
  @Override
  public GbtxParent unmarshal(GbtxType gbtx) throws Exception
  {
    if (gbtx.type.equals("i2c"))
    {
      return new GbtxDepp(gbtx.id,gbtx.mgt,gbtx.slaveAddress,gbtx.txBaseAddress,gbtx.rxBaseAddress);
    }
    else
    {
      return new GbtxIcDepp(gbtx.id,gbtx.mgt,gbtx.slaveAddress,gbtx.txBaseAddress,gbtx.rxBaseAddress);
    }	    
  }

// Dummy as we do not support marshalling
    
  @Override
  public GbtxType marshal(GbtxParent gbtx) throws Exception
  {
    return null;
  }
}
