package cbsw.lhcb.pdmdb;

/**
<p>Implements many of the static methods called by {@link Command}.</p>
*/
public class PdmdbTests
{
/**
<p>Performs test of SPI slave select signals.</p>
<p>Callable by {@link Command}</p>
<p>Asserts each slave select in turn and reads back the signal status.</p>
@param args Not used.
@return Command response.
*/
  public static String testSpiSlaveLines(String [] args)
  {
    StringBuffer sb = new StringBuffer();
    for (int slaveNo = 0; slaveNo<8; slaveNo++)
    {
      PdmdbMaster.pdmdbMaster.sca.allocateTxRxBuffers(0x01);
      PdmdbMaster.pdmdbMaster.sca.infoTx("SPI_W_SS",(1<<slaveNo));
      PdmdbMaster.pdmdbMaster.sca.putBytes(0,true);

      PdmdbModuleTester.exec("SPISLAVELINES");
      PdmdbModuleTester.rxSeq++;
      String [] ack = PdmdbModuleTester.readResponse(3000); // Reads the ACK_OK (should check it)
      String [] response = PdmdbModuleTester.readResponse(3000); // Reads the response
      sb.append("|"+response[3]); // Lazy coding, I assume data is 3rd token
    }
    return "OK|PdmdbTests.testSpiSlaveLines"+sb;
  }

}
