package cbsw.lhcb.pdmdb;

import javax.xml.bind.annotation.*;
import java.util.*;

/**
<p>This class encapsulates a collection of the SCA command responses.</p>
<p>Unmarshall SCA RX register descriptors into statically accessible members of this ScaRx class.</p>
**/
@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(name="scacommands")
class ScaRx
{
public static ArrayList<ScaCommandDescriptor> descriptors;
  public static HashMap< String, ScaCommandDescriptor > map;

  @XmlElement(name="SCACommand")
  public void setDescriptors(ArrayList<ScaCommandDescriptor> descriptors) { ScaRx.descriptors = descriptors; }
  public ArrayList<ScaCommandDescriptor> getDescriptors(){return descriptors;}
    
  static
  {
    cbsw.Cbsw.unmarshal("https://www.hep.phy.cam.ac.uk/lhcb/PDMDB/sca/SCARXCommands.xml",ScaRx.class);

    ScaRx.map = new HashMap< String, ScaCommandDescriptor >();

    ScaRx.descriptors.forEach(reg->map.put( reg.getName(), reg ));  
  }
    
  public ScaRx(){}

  public static ScaCommandDescriptor getDescriptor(String command)
  {

    String [] tokens = command.split("[_/]");
    String [] cmdch = command.split("/");
 
    ScaCommandDescriptor commandDescriptor;

    byte scaChannel;
    if (tokens[0].equals("I2C"))
    {
      commandDescriptor = map.get(cmdch[0]);      // I2C commands have bus number appended after "/"
    }
    else
    {
      commandDescriptor = map.get(command);    // For all other commands get channel from map
    }

    return commandDescriptor;
  }
    
  public static void main( String[] args )
  {
    ScaRx.descriptors.forEach(reg->System.out.println(reg.getName()));
  }

}

