#include <string.h>
#include <jni.h>
//#include "cbsw_adept_JniAdeptDepp.h"
#include "cbsw_adept_JniAdeptDepp_dmgr.h"
#include "cbsw_adept_JniAdeptDepp_depp.h"
#include "cbsw_adept_JniAdeptDepp_djtg.h"
#undef WIN32
#include "dpcdecl.h"
#include "depp.h"
#include "djtg.h"
#include "dmgr.h"
#define WIN32 1

HIF hif = hifInvalid;

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_enumerate(JNIEnv *env, jclass obj)
{
  int num = 0;
  BOOL rc = DmgrEnumDevices(&num);
  if (!rc) return 0;
  return num;
}

JNIEXPORT jstring JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_getEnumeratedDevice(JNIEnv *env, jclass obj, jint idx)
{
  DVC dvcInfo;
  BOOL rc = DmgrGetDvc(idx,&dvcInfo);
  char sn[cchSnMax+1];
  char unsn[cchUsrNameMax+cchSnMax+2];
  rc = DmgrGetInfo(&dvcInfo,dinfoUsrName,unsn);
  rc = DmgrGetInfo(&dvcInfo,dinfoSN,sn);
  strcat(unsn,"/"); strcat(unsn,sn);
  //  jstring dvcString = env->NewStringUTF(dvcInfo.szConn);
  jstring dvcString = env->NewStringUTF(unsn);
  return dvcString;
}

JNIEXPORT jstring JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_getCapabilities(JNIEnv *env, jclass obj, jint idx)
{
  DVC dvcInfo;
  DCAP caps;
  BOOL rc = DmgrGetDvc(idx,&dvcInfo);
  char scaps[64]; scaps[0] = 0;
  rc = DmgrGetInfo(&dvcInfo,dinfoDCAP,&caps);
  if ((caps & dcapJtag) != 0) strcat(scaps,"DJTG:");
  if ((caps & dcapPio) != 0) strcat(scaps,"DPIO:");
  if ((caps & dcapEpp) != 0) strcat(scaps,"DEPP:");
  if ((caps & dcapStm) != 0) strcat(scaps,"DSTM:");
  if ((caps & dcapSpi) != 0) strcat(scaps,"DSPI:");
  if ((caps & dcapTwi) != 0) strcat(scaps,"DTWI:");
  if ((caps & dcapAci) != 0) strcat(scaps,"DACI:");
  if ((caps & dcapAio) != 0) strcat(scaps,"DAIO:");
  if ((caps & dcapEmc) != 0) strcat(scaps,"DEMC:");
  if ((caps & dcapGio) != 0) strcat(scaps,"DGIO:");

  //  jstring dvcString = env->NewStringUTF(dvcInfo.szConn);
  jstring dvcString = env->NewStringUTF(scaps);
  return dvcString;
}

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_getLastError (JNIEnv *env, jclass obj)
{
  return DmgrGetLastError();
}

JNIEXPORT jstring JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_getLastErrorName(JNIEnv *env, jclass obj, jint code)
{
  char szErc[cchErcMax];
  char szErcMessage[cchErcMsgMax];
  DmgrSzFromErc(code,szErc,szErcMessage);
  jstring ercString = env->NewStringUTF(szErc);
  return ercString;
}

JNIEXPORT jstring JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_getLastErrorDescription(JNIEnv *env, jclass obj, jint code)
{
  char szErc[cchErcMax];
  char szErcMessage[cchErcMsgMax];
  DmgrSzFromErc(code,szErc,szErcMessage);
  jstring ercMsgString = env->NewStringUTF(szErcMessage);
  return ercMsgString;
}

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_open(JNIEnv *env, jclass obj, jstring deviceString)
{
  const char *name = env->GetStringUTFChars( deviceString, 0 );
  char dv[64];
  strcpy(dv, name);

  hif = hifInvalid;
  BOOL rc = DmgrOpen(&hif, dv);
  if( !rc ) return 0;

  return 1;
}

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024dmgr_close(JNIEnv *env, jclass obj)
{
  if ( hif != hifInvalid )
  {
    DmgrClose(hif);
  }
  return 1;
}

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024depp_enable(JNIEnv *env, jclass cl)
{
  BOOL rc = DeppEnable(hif);
  return (rc ? true : false);
}

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024depp_disable(JNIEnv *env, jclass cl)
{
  BOOL rc = DeppDisable(hif);
  return (rc ? true : false);
}

// Multiple read of addr,data pairs

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024depp_getSet(JNIEnv *env, jclass obj, jbyteArray addrArray, jbyteArray dataArray )
{
  jsize addrArrayLength = env->GetArrayLength( addrArray );
  jsize dataArrayLength = env->GetArrayLength( dataArray );

  jbyte *addr = env->GetByteArrayElements( addrArray, 0 );
  jbyte *data = env->GetByteArrayElements( dataArray, 0 );

  DWORD nget = (dataArrayLength<addrArrayLength) ? dataArrayLength : addrArrayLength;

  BOOL rc = DeppGetRegSet(hif, reinterpret_cast<BYTE *>(addr), reinterpret_cast<BYTE *>(data), nget, fFalse);

  env->ReleaseByteArrayElements( addrArray, addr, 0 );
  env->ReleaseByteArrayElements( dataArray, data, 0 );

  return rc?1:0;
}

// Multiple write of addr,data pairs

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024depp_putSet(JNIEnv *env, jclass obj, jbyteArray buf )
{
  jsize len = env->GetArrayLength( buf );
  jbyte *array = env->GetByteArrayElements( buf, 0 );

  DWORD npairs = 0; npairs |= (len>>1); // Buffer length/2

  BOOL rc = DeppPutRegSet(hif, reinterpret_cast<BYTE *>(array), npairs, fFalse);

  env->ReleaseByteArrayElements( buf, array, 0 );

  return rc?1:0;
}

// Multiple write to same address

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024depp_putRepeat(JNIEnv *env, jclass obj, jbyte addr, jbyteArray buf)
{
  jsize len = env->GetArrayLength( buf );
  jbyte *array = env->GetByteArrayElements( buf, 0 );

// Byte is signed in Java so can't simply cast the address

  BYTE uaddr = 0; uaddr |= addr;
  DWORD ulen = 0; ulen |= len;

  BOOL rc = DeppPutRegRepeat(hif, uaddr, reinterpret_cast<BYTE *>(array), ulen, fFalse);

  env->ReleaseByteArrayElements( buf, array, 0 );

  return rc?1:0;
}
// Multiple write to same address

JNIEXPORT jint JNICALL Java_cbsw_adept_JniAdeptDepp_00024depp_getRepeat(JNIEnv *env, jclass obj, jbyte addr, jbyteArray buf)
{
  jsize len = env->GetArrayLength( buf );
  jbyte *array = env->GetByteArrayElements( buf, 0 );

// Byte is signed in Java so can't simply cast the address

  BYTE uaddr = 0; uaddr |= addr;
  DWORD ulen = 0; ulen |= len;

  BOOL rc = DeppGetRegRepeat(hif, uaddr, reinterpret_cast<BYTE *>(array), ulen, fFalse);

  env->ReleaseByteArrayElements( buf, array, 0 );

  return rc?1:0;
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_enable(JNIEnv *env, jclass obj)
{
  BOOL rc = DjtgEnable(hif);
  return (rc ? true : false);
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_disable(JNIEnv *env, jclass obj)
{
  BOOL rc = DjtgDisable(hif);
  return (rc ? true : false);
}

JNIEXPORT jstring JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_getProperties(JNIEnv *env, jclass obj, jint idx)
{
  char capstr[256];

  INT32 pcprt;
  BOOL rc = DjtgGetPortCount(hif,&pcprt);
  if (!rc)
  {
    jstring dvcString = env->NewStringUTF("");
    return dvcString;
  }
  sprintf(capstr,"%d ports found.",pcprt);

  DWORD pdprp;
  rc = DjtgGetPortProperties(hif,idx,&pdprp);
  if (!rc)
  {
    jstring dvcString = env->NewStringUTF("");
    return dvcString;
  }

  strcat(capstr," Port capabilities");
  if (pdprp & dprpJtgSetSpeed) { strcat(capstr,":DjtgSetSpeed"); }
  if (pdprp & dprpJtgSetPinState) { strcat(capstr,":DjtgSetTmsTdiTck"); }
  if (pdprp & dprpJtgWait) { strcat(capstr,":DjtgWait"); }
  if (pdprp & dprpJtgSetAuxReset) { strcat(capstr,":DjtgSetAuxReset"); }
  if (pdprp & dprpJtgBatch) { strcat(capstr,":DjtgBatch"); }

  UINT32 pdjbp;
  rc = DjtgGetBatchProperties(hif,idx,&pdjbp);
  if (!rc)
  {
    jstring dvcString = env->NewStringUTF(capstr);
    return dvcString;
  }
  strcat(capstr," Batch capabilities");
  if (pdjbp & djbpWaitUs) { strcat(capstr,":jcbWaitUs"); }
  if (pdjbp & djbpSetAuxReset) { strcat(capstr,":jcbSetAuxReset"); }

  jstring dvcString = env->NewStringUTF(capstr);
  return dvcString;
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_putTmsTdi__I_3B_3B(JNIEnv *env, jclass obj, jint bits, jbyteArray snd, jbyteArray rcv)
{
  jsize sndLength = env->GetArrayLength( snd );
  jbyte *sndArray = env->GetByteArrayElements( snd, 0 );
  jbyte *rcvArray = env->GetByteArrayElements( rcv, 0 );

  DWORD ulen = 0; ulen |= bits;
  BOOL rc = DjtgPutTmsTdiBits(hif, reinterpret_cast<BYTE *>(sndArray), reinterpret_cast<BYTE *>(rcvArray), ulen, fFalse);

  env->ReleaseByteArrayElements( snd, sndArray, 0 );
  env->ReleaseByteArrayElements( rcv, rcvArray, 0 );

  return (rc?true:false);
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_putTmsTdi__I_3B(JNIEnv *env, jclass obj, jint bits, jbyteArray snd)
{
  jsize sndLength = env->GetArrayLength( snd );
  jbyte *sndArray = env->GetByteArrayElements( snd, 0 );

  DWORD ulen = 0; ulen |= bits;
  BOOL rc = DjtgPutTmsTdiBits(hif, reinterpret_cast<BYTE *>(sndArray), NULL, ulen, fFalse);

  env->ReleaseByteArrayElements( snd, sndArray, 0 );

  return (rc?true:false);
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_putTms__I_3B_3BZ(JNIEnv *env, jclass obj, jint bits, jbyteArray snd, jbyteArray rcv, jboolean tdi)
{
  jsize sndLength = env->GetArrayLength( snd );
  jbyte *sndArray = env->GetByteArrayElements( snd, 0 );
  jbyte *rcvArray = env->GetByteArrayElements( rcv, 0 );

  DWORD ulen = 0; ulen |= bits;
  BOOL rc = DjtgPutTmsBits(hif, tdi, reinterpret_cast<BYTE *>(sndArray), reinterpret_cast<BYTE *>(rcvArray), ulen, fFalse);

  env->ReleaseByteArrayElements( snd, sndArray, 0 );
  env->ReleaseByteArrayElements( rcv, rcvArray, 0 );

  return (rc?true:false);
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_putTms__I_3BZ(JNIEnv *env, jclass obj, jint bits, jbyteArray snd, jboolean tdi)
{
  jsize sndLength = env->GetArrayLength( snd );
  jbyte *sndArray = env->GetByteArrayElements( snd, 0 );

  DWORD ulen = 0; ulen |= bits;
  BOOL rc = DjtgPutTmsBits(hif, tdi, reinterpret_cast<BYTE *>(sndArray), NULL, ulen, fFalse);

  env->ReleaseByteArrayElements( snd, sndArray, 0 );

  return (rc?true:false);
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_putTdi__I_3B_3BZ(JNIEnv *env, jclass obj, jint bits, jbyteArray snd, jbyteArray rcv, jboolean tms)
{
  jsize sndLength = env->GetArrayLength( snd );
  jbyte *sndArray = env->GetByteArrayElements( snd, 0 );
  jbyte *rcvArray = env->GetByteArrayElements( rcv, 0 );

  DWORD ulen = 0; ulen |= bits;
  BOOL rc = DjtgPutTdiBits(hif, tms, reinterpret_cast<BYTE *>(sndArray), reinterpret_cast<BYTE *>(rcvArray), ulen, fFalse);

  env->ReleaseByteArrayElements( snd, sndArray, 0 );
  env->ReleaseByteArrayElements( rcv, rcvArray, 0 );

  return (rc?true:false);
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_putTdi__I_3BZ(JNIEnv *env, jclass obj, jint bits, jbyteArray snd, jboolean tms)
{
  jsize sndLength = env->GetArrayLength( snd );
  jbyte *sndArray = env->GetByteArrayElements( snd, 0 );

  DWORD ulen = 0; ulen |= bits;
  BOOL rc = DjtgPutTdiBits(hif, tms, reinterpret_cast<BYTE *>(sndArray), NULL, ulen, fFalse);

  env->ReleaseByteArrayElements( snd, sndArray, 0 );

  return (rc?true:false);
}

JNIEXPORT jboolean JNICALL Java_cbsw_adept_JniAdeptDepp_00024djtg_clock(JNIEnv *env, jclass obj, jboolean tms, jboolean tdi, jint clks)
{
  DWORD ulen = 0; ulen |= clks;
  BOOL rc = DjtgClockTck(hif, tms, tdi, ulen, fFalse);

  return (rc?true:false);
}
