package cbsw.gui;

import java.io.*;
import java.awt.event.*;
import java.awt.Component;
import java.awt.Container;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.prefs.Preferences;

public class NetPreferences extends GuiJPanel
{
JPanel macPanel;
JPanel ipPanel;
JComboBox<String> dbCB;

  ActionListener dbCBAL = new ActionListener () { public void actionPerformed(ActionEvent e)
      {
	setPrefsUserNode(prefs.parent().node((String)dbCB.getSelectedItem()),"db.");
	GuiJPanel.updateUndefinedFields(prefs,NetPreferences.this);
      }
    };

public JPanel makeMacPanel()
{
  JPanel jP = new JPanel();
  jP.setLayout( new GridBagLayout() );
  GridBagConstraints gbC = new GridBagConstraints();
  jP.setBorder( BorderFactory.createTitledBorder("MAC address") );

  gbC.fill = GridBagConstraints.NONE;
  gbC.anchor = GridBagConstraints.CENTER;
  gbC.insets = new Insets(2,2,2,2);

  for ( int i=0; i<6; i++ )
  {
    JTextField macTF;
    if (i == 0)
    {
      macTF = new JTextField(prefs.get(String.format(prefsPrefix+"mac.%1$d",5-i),"02"),2);
    }
    else
    {
      macTF = new JTextField(prefs.get(String.format(prefsPrefix+"mac.%1$d",5-i),"00"),2);
    }
    macTF.setName(prefsPrefix+String.format("mac.%1$d",5-i));
    jP.add( macTF );
    if (i<5 ) jP.add( new JLabel( ":" ) );
  }

  return jP;
}

public JPanel makeIpPanel()
{
  JPanel jP = new JPanel();
  jP.setLayout( new GridBagLayout() );
  GridBagConstraints gbC = new GridBagConstraints();
  jP.setBorder( BorderFactory.createTitledBorder("IP address") );

  gbC.fill = GridBagConstraints.NONE;
  gbC.anchor = GridBagConstraints.CENTER;
  gbC.insets = new Insets(2,2,2,2);

  for ( int i=0; i<4; i++ )
  {
    JTextField ipTF = new JTextField(prefs.get(String.format(prefsPrefix+"ip.%1$d",3-i),"0"),3);
    ipTF.setName(prefsPrefix+String.format("ip.%1$d",3-i));
    jP.add( ipTF );
    if (i<3) jP.add( new JLabel( "." ) );
  }

  return jP;
}

  public NetPreferences( Preferences pfs, String pfx )
  {
    super(pfs,pfx);

    setLayout( new GridBagLayout() );
    GridBagConstraints gbC = new GridBagConstraints();
    gbC.fill = GridBagConstraints.NONE;
    gbC.anchor = GridBagConstraints.CENTER;
    gbC.insets = new Insets(2,2,2,2);

    dbCB = new JComboBox<String>();
    try
    {
      String [] dnaList = prefs.parent().childrenNames();

      for( int i=0 ; i<dnaList.length; i++)
      {
	dbCB.addItem(dnaList[i]);
      }
    } catch ( Exception e ) {}
    dbCB.addActionListener( dbCBAL );
    gbC.gridwidth = GridBagConstraints.REMAINDER;
    add(dbCB,gbC);

    gbC.gridwidth = GridBagConstraints.REMAINDER;
    macPanel = makeMacPanel();
    add(macPanel , gbC);

    gbC.gridwidth = GridBagConstraints.REMAINDER;
    ipPanel = makeIpPanel();
    add(ipPanel , gbC);

  }

}
